package com.mvc.entity;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class TIdentEnquiriesExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public TIdentEnquiriesExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("ID is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("ID is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Integer value) {
            addCriterion("ID =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Integer value) {
            addCriterion("ID <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Integer value) {
            addCriterion("ID >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("ID >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Integer value) {
            addCriterion("ID <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Integer value) {
            addCriterion("ID <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Integer> values) {
            addCriterion("ID in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Integer> values) {
            addCriterion("ID not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Integer value1, Integer value2) {
            addCriterion("ID between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Integer value1, Integer value2) {
            addCriterion("ID not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andDeviceSnIsNull() {
            addCriterion("DEVICE_SN is null");
            return (Criteria) this;
        }

        public Criteria andDeviceSnIsNotNull() {
            addCriterion("DEVICE_SN is not null");
            return (Criteria) this;
        }

        public Criteria andDeviceSnEqualTo(String value) {
            addCriterion("DEVICE_SN =", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnNotEqualTo(String value) {
            addCriterion("DEVICE_SN <>", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnGreaterThan(String value) {
            addCriterion("DEVICE_SN >", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnGreaterThanOrEqualTo(String value) {
            addCriterion("DEVICE_SN >=", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnLessThan(String value) {
            addCriterion("DEVICE_SN <", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnLessThanOrEqualTo(String value) {
            addCriterion("DEVICE_SN <=", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnLike(String value) {
            addCriterion("DEVICE_SN like", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnNotLike(String value) {
            addCriterion("DEVICE_SN not like", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnIn(List<String> values) {
            addCriterion("DEVICE_SN in", values, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnNotIn(List<String> values) {
            addCriterion("DEVICE_SN not in", values, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnBetween(String value1, String value2) {
            addCriterion("DEVICE_SN between", value1, value2, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnNotBetween(String value1, String value2) {
            addCriterion("DEVICE_SN not between", value1, value2, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andStationCodeIsNull() {
            addCriterion("STATION_CODE is null");
            return (Criteria) this;
        }

        public Criteria andStationCodeIsNotNull() {
            addCriterion("STATION_CODE is not null");
            return (Criteria) this;
        }

        public Criteria andStationCodeEqualTo(String value) {
            addCriterion("STATION_CODE =", value, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeNotEqualTo(String value) {
            addCriterion("STATION_CODE <>", value, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeGreaterThan(String value) {
            addCriterion("STATION_CODE >", value, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeGreaterThanOrEqualTo(String value) {
            addCriterion("STATION_CODE >=", value, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeLessThan(String value) {
            addCriterion("STATION_CODE <", value, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeLessThanOrEqualTo(String value) {
            addCriterion("STATION_CODE <=", value, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeLike(String value) {
            addCriterion("STATION_CODE like", value, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeNotLike(String value) {
            addCriterion("STATION_CODE not like", value, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeIn(List<String> values) {
            addCriterion("STATION_CODE in", values, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeNotIn(List<String> values) {
            addCriterion("STATION_CODE not in", values, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeBetween(String value1, String value2) {
            addCriterion("STATION_CODE between", value1, value2, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationCodeNotBetween(String value1, String value2) {
            addCriterion("STATION_CODE not between", value1, value2, "stationCode");
            return (Criteria) this;
        }

        public Criteria andStationNameIsNull() {
            addCriterion("STATION_NAME is null");
            return (Criteria) this;
        }

        public Criteria andStationNameIsNotNull() {
            addCriterion("STATION_NAME is not null");
            return (Criteria) this;
        }

        public Criteria andStationNameEqualTo(String value) {
            addCriterion("STATION_NAME =", value, "stationName");
            return (Criteria) this;
        }

        public Criteria andStationNameNotEqualTo(String value) {
            addCriterion("STATION_NAME <>", value, "stationName");
            return (Criteria) this;
        }

        public Criteria andStationNameGreaterThan(String value) {
            addCriterion("STATION_NAME >", value, "stationName");
            return (Criteria) this;
        }

        public Criteria andStationNameGreaterThanOrEqualTo(String value) {
            addCriterion("STATION_NAME >=", value, "stationName");
            return (Criteria) this;
        }

        public Criteria andStationNameLessThan(String value) {
            addCriterion("STATION_NAME <", value, "stationName");
            return (Criteria) this;
        }

        public Criteria andStationNameLessThanOrEqualTo(String value) {
            addCriterion("STATION_NAME <=", value, "stationName");
            return (Criteria) this;
        }

        public Criteria andStationNameLike(String value) {
            addCriterion("STATION_NAME like", value, "stationName");
            return (Criteria) this;
        }

        public Criteria andStationNameNotLike(String value) {
            addCriterion("STATION_NAME not like", value, "stationName");
            return (Criteria) this;
        }

        public Criteria andStationNameIn(List<String> values) {
            addCriterion("STATION_NAME in", values, "stationName");
            return (Criteria) this;
        }

        public Criteria andStationNameNotIn(List<String> values) {
            addCriterion("STATION_NAME not in", values, "stationName");
            return (Criteria) this;
        }

        public Criteria andStationNameBetween(String value1, String value2) {
            addCriterion("STATION_NAME between", value1, value2, "stationName");
            return (Criteria) this;
        }

        public Criteria andStationNameNotBetween(String value1, String value2) {
            addCriterion("STATION_NAME not between", value1, value2, "stationName");
            return (Criteria) this;
        }

        public Criteria andUnitCodeIsNull() {
            addCriterion("UNIT_CODE is null");
            return (Criteria) this;
        }

        public Criteria andUnitCodeIsNotNull() {
            addCriterion("UNIT_CODE is not null");
            return (Criteria) this;
        }

        public Criteria andUnitCodeEqualTo(String value) {
            addCriterion("UNIT_CODE =", value, "unitCode");
            return (Criteria) this;
        }

        public Criteria andUnitCodeNotEqualTo(String value) {
            addCriterion("UNIT_CODE <>", value, "unitCode");
            return (Criteria) this;
        }

        public Criteria andUnitCodeGreaterThan(String value) {
            addCriterion("UNIT_CODE >", value, "unitCode");
            return (Criteria) this;
        }

        public Criteria andUnitCodeGreaterThanOrEqualTo(String value) {
            addCriterion("UNIT_CODE >=", value, "unitCode");
            return (Criteria) this;
        }

        public Criteria andUnitCodeLessThan(String value) {
            addCriterion("UNIT_CODE <", value, "unitCode");
            return (Criteria) this;
        }

        public Criteria andUnitCodeLessThanOrEqualTo(String value) {
            addCriterion("UNIT_CODE <=", value, "unitCode");
            return (Criteria) this;
        }

        public Criteria andUnitCodeLike(String value) {
            addCriterion("UNIT_CODE like", value, "unitCode");
            return (Criteria) this;
        }

        public Criteria andUnitCodeNotLike(String value) {
            addCriterion("UNIT_CODE not like", value, "unitCode");
            return (Criteria) this;
        }

        public Criteria andUnitCodeIn(List<String> values) {
            addCriterion("UNIT_CODE in", values, "unitCode");
            return (Criteria) this;
        }

        public Criteria andUnitCodeNotIn(List<String> values) {
            addCriterion("UNIT_CODE not in", values, "unitCode");
            return (Criteria) this;
        }

        public Criteria andUnitCodeBetween(String value1, String value2) {
            addCriterion("UNIT_CODE between", value1, value2, "unitCode");
            return (Criteria) this;
        }

        public Criteria andUnitCodeNotBetween(String value1, String value2) {
            addCriterion("UNIT_CODE not between", value1, value2, "unitCode");
            return (Criteria) this;
        }

        public Criteria andDeviceTypeIsNull() {
            addCriterion("DEVICE_TYPE is null");
            return (Criteria) this;
        }

        public Criteria andDeviceTypeIsNotNull() {
            addCriterion("DEVICE_TYPE is not null");
            return (Criteria) this;
        }

        public Criteria andDeviceTypeEqualTo(String value) {
            addCriterion("DEVICE_TYPE =", value, "deviceType");
            return (Criteria) this;
        }

        public Criteria andDeviceTypeNotEqualTo(String value) {
            addCriterion("DEVICE_TYPE <>", value, "deviceType");
            return (Criteria) this;
        }

        public Criteria andDeviceTypeGreaterThan(String value) {
            addCriterion("DEVICE_TYPE >", value, "deviceType");
            return (Criteria) this;
        }

        public Criteria andDeviceTypeGreaterThanOrEqualTo(String value) {
            addCriterion("DEVICE_TYPE >=", value, "deviceType");
            return (Criteria) this;
        }

        public Criteria andDeviceTypeLessThan(String value) {
            addCriterion("DEVICE_TYPE <", value, "deviceType");
            return (Criteria) this;
        }

        public Criteria andDeviceTypeLessThanOrEqualTo(String value) {
            addCriterion("DEVICE_TYPE <=", value, "deviceType");
            return (Criteria) this;
        }

        public Criteria andDeviceTypeLike(String value) {
            addCriterion("DEVICE_TYPE like", value, "deviceType");
            return (Criteria) this;
        }

        public Criteria andDeviceTypeNotLike(String value) {
            addCriterion("DEVICE_TYPE not like", value, "deviceType");
            return (Criteria) this;
        }

        public Criteria andDeviceTypeIn(List<String> values) {
            addCriterion("DEVICE_TYPE in", values, "deviceType");
            return (Criteria) this;
        }

        public Criteria andDeviceTypeNotIn(List<String> values) {
            addCriterion("DEVICE_TYPE not in", values, "deviceType");
            return (Criteria) this;
        }

        public Criteria andDeviceTypeBetween(String value1, String value2) {
            addCriterion("DEVICE_TYPE between", value1, value2, "deviceType");
            return (Criteria) this;
        }

        public Criteria andDeviceTypeNotBetween(String value1, String value2) {
            addCriterion("DEVICE_TYPE not between", value1, value2, "deviceType");
            return (Criteria) this;
        }

        public Criteria andAiVersionIsNull() {
            addCriterion("AI_VERSION is null");
            return (Criteria) this;
        }

        public Criteria andAiVersionIsNotNull() {
            addCriterion("AI_VERSION is not null");
            return (Criteria) this;
        }

        public Criteria andAiVersionEqualTo(String value) {
            addCriterion("AI_VERSION =", value, "aiVersion");
            return (Criteria) this;
        }

        public Criteria andAiVersionNotEqualTo(String value) {
            addCriterion("AI_VERSION <>", value, "aiVersion");
            return (Criteria) this;
        }

        public Criteria andAiVersionGreaterThan(String value) {
            addCriterion("AI_VERSION >", value, "aiVersion");
            return (Criteria) this;
        }

        public Criteria andAiVersionGreaterThanOrEqualTo(String value) {
            addCriterion("AI_VERSION >=", value, "aiVersion");
            return (Criteria) this;
        }

        public Criteria andAiVersionLessThan(String value) {
            addCriterion("AI_VERSION <", value, "aiVersion");
            return (Criteria) this;
        }

        public Criteria andAiVersionLessThanOrEqualTo(String value) {
            addCriterion("AI_VERSION <=", value, "aiVersion");
            return (Criteria) this;
        }

        public Criteria andAiVersionLike(String value) {
            addCriterion("AI_VERSION like", value, "aiVersion");
            return (Criteria) this;
        }

        public Criteria andAiVersionNotLike(String value) {
            addCriterion("AI_VERSION not like", value, "aiVersion");
            return (Criteria) this;
        }

        public Criteria andAiVersionIn(List<String> values) {
            addCriterion("AI_VERSION in", values, "aiVersion");
            return (Criteria) this;
        }

        public Criteria andAiVersionNotIn(List<String> values) {
            addCriterion("AI_VERSION not in", values, "aiVersion");
            return (Criteria) this;
        }

        public Criteria andAiVersionBetween(String value1, String value2) {
            addCriterion("AI_VERSION between", value1, value2, "aiVersion");
            return (Criteria) this;
        }

        public Criteria andAiVersionNotBetween(String value1, String value2) {
            addCriterion("AI_VERSION not between", value1, value2, "aiVersion");
            return (Criteria) this;
        }

        public Criteria andAicbqCfgIdIsNull() {
            addCriterion("AICBQ_CFG_ID is null");
            return (Criteria) this;
        }

        public Criteria andAicbqCfgIdIsNotNull() {
            addCriterion("AICBQ_CFG_ID is not null");
            return (Criteria) this;
        }

        public Criteria andAicbqCfgIdEqualTo(Integer value) {
            addCriterion("AICBQ_CFG_ID =", value, "aicbqCfgId");
            return (Criteria) this;
        }

        public Criteria andAicbqCfgIdNotEqualTo(Integer value) {
            addCriterion("AICBQ_CFG_ID <>", value, "aicbqCfgId");
            return (Criteria) this;
        }

        public Criteria andAicbqCfgIdGreaterThan(Integer value) {
            addCriterion("AICBQ_CFG_ID >", value, "aicbqCfgId");
            return (Criteria) this;
        }

        public Criteria andAicbqCfgIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("AICBQ_CFG_ID >=", value, "aicbqCfgId");
            return (Criteria) this;
        }

        public Criteria andAicbqCfgIdLessThan(Integer value) {
            addCriterion("AICBQ_CFG_ID <", value, "aicbqCfgId");
            return (Criteria) this;
        }

        public Criteria andAicbqCfgIdLessThanOrEqualTo(Integer value) {
            addCriterion("AICBQ_CFG_ID <=", value, "aicbqCfgId");
            return (Criteria) this;
        }

        public Criteria andAicbqCfgIdIn(List<Integer> values) {
            addCriterion("AICBQ_CFG_ID in", values, "aicbqCfgId");
            return (Criteria) this;
        }

        public Criteria andAicbqCfgIdNotIn(List<Integer> values) {
            addCriterion("AICBQ_CFG_ID not in", values, "aicbqCfgId");
            return (Criteria) this;
        }

        public Criteria andAicbqCfgIdBetween(Integer value1, Integer value2) {
            addCriterion("AICBQ_CFG_ID between", value1, value2, "aicbqCfgId");
            return (Criteria) this;
        }

        public Criteria andAicbqCfgIdNotBetween(Integer value1, Integer value2) {
            addCriterion("AICBQ_CFG_ID not between", value1, value2, "aicbqCfgId");
            return (Criteria) this;
        }

        public Criteria andEnableNoconfigManualConfigIsNull() {
            addCriterion("ENABLE_NOCONFIG_MANUAL_CONFIG is null");
            return (Criteria) this;
        }

        public Criteria andEnableNoconfigManualConfigIsNotNull() {
            addCriterion("ENABLE_NOCONFIG_MANUAL_CONFIG is not null");
            return (Criteria) this;
        }

        public Criteria andEnableNoconfigManualConfigEqualTo(String value) {
            addCriterion("ENABLE_NOCONFIG_MANUAL_CONFIG =", value, "enableNoconfigManualConfig");
            return (Criteria) this;
        }

        public Criteria andEnableNoconfigManualConfigNotEqualTo(String value) {
            addCriterion("ENABLE_NOCONFIG_MANUAL_CONFIG <>", value, "enableNoconfigManualConfig");
            return (Criteria) this;
        }

        public Criteria andEnableNoconfigManualConfigGreaterThan(String value) {
            addCriterion("ENABLE_NOCONFIG_MANUAL_CONFIG >", value, "enableNoconfigManualConfig");
            return (Criteria) this;
        }

        public Criteria andEnableNoconfigManualConfigGreaterThanOrEqualTo(String value) {
            addCriterion("ENABLE_NOCONFIG_MANUAL_CONFIG >=", value, "enableNoconfigManualConfig");
            return (Criteria) this;
        }

        public Criteria andEnableNoconfigManualConfigLessThan(String value) {
            addCriterion("ENABLE_NOCONFIG_MANUAL_CONFIG <", value, "enableNoconfigManualConfig");
            return (Criteria) this;
        }

        public Criteria andEnableNoconfigManualConfigLessThanOrEqualTo(String value) {
            addCriterion("ENABLE_NOCONFIG_MANUAL_CONFIG <=", value, "enableNoconfigManualConfig");
            return (Criteria) this;
        }

        public Criteria andEnableNoconfigManualConfigLike(String value) {
            addCriterion("ENABLE_NOCONFIG_MANUAL_CONFIG like", value, "enableNoconfigManualConfig");
            return (Criteria) this;
        }

        public Criteria andEnableNoconfigManualConfigNotLike(String value) {
            addCriterion("ENABLE_NOCONFIG_MANUAL_CONFIG not like", value, "enableNoconfigManualConfig");
            return (Criteria) this;
        }

        public Criteria andEnableNoconfigManualConfigIn(List<String> values) {
            addCriterion("ENABLE_NOCONFIG_MANUAL_CONFIG in", values, "enableNoconfigManualConfig");
            return (Criteria) this;
        }

        public Criteria andEnableNoconfigManualConfigNotIn(List<String> values) {
            addCriterion("ENABLE_NOCONFIG_MANUAL_CONFIG not in", values, "enableNoconfigManualConfig");
            return (Criteria) this;
        }

        public Criteria andEnableNoconfigManualConfigBetween(String value1, String value2) {
            addCriterion("ENABLE_NOCONFIG_MANUAL_CONFIG between", value1, value2, "enableNoconfigManualConfig");
            return (Criteria) this;
        }

        public Criteria andEnableNoconfigManualConfigNotBetween(String value1, String value2) {
            addCriterion("ENABLE_NOCONFIG_MANUAL_CONFIG not between", value1, value2, "enableNoconfigManualConfig");
            return (Criteria) this;
        }

        public Criteria andIdentFlagIsNull() {
            addCriterion("IDENT_FLAG is null");
            return (Criteria) this;
        }

        public Criteria andIdentFlagIsNotNull() {
            addCriterion("IDENT_FLAG is not null");
            return (Criteria) this;
        }

        public Criteria andIdentFlagEqualTo(Integer value) {
            addCriterion("IDENT_FLAG =", value, "identFlag");
            return (Criteria) this;
        }

        public Criteria andIdentFlagNotEqualTo(Integer value) {
            addCriterion("IDENT_FLAG <>", value, "identFlag");
            return (Criteria) this;
        }

        public Criteria andIdentFlagGreaterThan(Integer value) {
            addCriterion("IDENT_FLAG >", value, "identFlag");
            return (Criteria) this;
        }

        public Criteria andIdentFlagGreaterThanOrEqualTo(Integer value) {
            addCriterion("IDENT_FLAG >=", value, "identFlag");
            return (Criteria) this;
        }

        public Criteria andIdentFlagLessThan(Integer value) {
            addCriterion("IDENT_FLAG <", value, "identFlag");
            return (Criteria) this;
        }

        public Criteria andIdentFlagLessThanOrEqualTo(Integer value) {
            addCriterion("IDENT_FLAG <=", value, "identFlag");
            return (Criteria) this;
        }

        public Criteria andIdentFlagIn(List<Integer> values) {
            addCriterion("IDENT_FLAG in", values, "identFlag");
            return (Criteria) this;
        }

        public Criteria andIdentFlagNotIn(List<Integer> values) {
            addCriterion("IDENT_FLAG not in", values, "identFlag");
            return (Criteria) this;
        }

        public Criteria andIdentFlagBetween(Integer value1, Integer value2) {
            addCriterion("IDENT_FLAG between", value1, value2, "identFlag");
            return (Criteria) this;
        }

        public Criteria andIdentFlagNotBetween(Integer value1, Integer value2) {
            addCriterion("IDENT_FLAG not between", value1, value2, "identFlag");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("CREATE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("CREATE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("CREATE_TIME =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("CREATE_TIME <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("CREATE_TIME >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("CREATE_TIME >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("CREATE_TIME <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("CREATE_TIME <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("CREATE_TIME in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("CREATE_TIME not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("CREATE_TIME between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("CREATE_TIME not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andAccuracyRateIsNull() {
            addCriterion("ACCURACY_RATE is null");
            return (Criteria) this;
        }

        public Criteria andAccuracyRateIsNotNull() {
            addCriterion("ACCURACY_RATE is not null");
            return (Criteria) this;
        }

        public Criteria andAccuracyRateEqualTo(Double value) {
            addCriterion("ACCURACY_RATE =", value, "accuracyRate");
            return (Criteria) this;
        }

        public Criteria andAccuracyRateNotEqualTo(Double value) {
            addCriterion("ACCURACY_RATE <>", value, "accuracyRate");
            return (Criteria) this;
        }

        public Criteria andAccuracyRateGreaterThan(Double value) {
            addCriterion("ACCURACY_RATE >", value, "accuracyRate");
            return (Criteria) this;
        }

        public Criteria andAccuracyRateGreaterThanOrEqualTo(Double value) {
            addCriterion("ACCURACY_RATE >=", value, "accuracyRate");
            return (Criteria) this;
        }

        public Criteria andAccuracyRateLessThan(Double value) {
            addCriterion("ACCURACY_RATE <", value, "accuracyRate");
            return (Criteria) this;
        }

        public Criteria andAccuracyRateLessThanOrEqualTo(Double value) {
            addCriterion("ACCURACY_RATE <=", value, "accuracyRate");
            return (Criteria) this;
        }

        public Criteria andAccuracyRateIn(List<Double> values) {
            addCriterion("ACCURACY_RATE in", values, "accuracyRate");
            return (Criteria) this;
        }

        public Criteria andAccuracyRateNotIn(List<Double> values) {
            addCriterion("ACCURACY_RATE not in", values, "accuracyRate");
            return (Criteria) this;
        }

        public Criteria andAccuracyRateBetween(Double value1, Double value2) {
            addCriterion("ACCURACY_RATE between", value1, value2, "accuracyRate");
            return (Criteria) this;
        }

        public Criteria andAccuracyRateNotBetween(Double value1, Double value2) {
            addCriterion("ACCURACY_RATE not between", value1, value2, "accuracyRate");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}